#!/usr/bin/perl
require "cgi-lib.pl";
require "bbconfig";
&ReadParse(*values); 
$user = $ENV{'REMOTE_USER'};
chomp($user);

$NUMBER=$values{"post"};
chomp($NUMBER);

unless ($values{"confirmed"}) {
	&ConfirmDeletion;
}

$deleteme=&FindIt($NUMBER);		#moved to bbconfig

open(TEMP_IN, $deleteme) || PrintError("Couldn't open article $post. <p>");
$owner = <TEMP_IN>;
chomp($owner);
if ($user ne $owner && $user ne $ADMINUSER) {
        print "Content-type: text/html\n\n";
        print "<HEAD><TITLE>Access Denied!</TITLE>\n";
        print "<meta HTTP-EQUIV=\"Refresh\" Content=\"4; URL=$RELCGI/htmls.pl/$cat/bbmain\">";
        print "\n</HEAD>\n";
        print "<BODY><CENTER>\n<H1>YOU ARE NOT THE OWNER OF THIS ARTICLE";
        print "</H1>\n<BR>You do not own this article, so what makes you";
        print " think you can delete it?  Don't be a jerk.\n</BODY>";
        exit 0;
}

if ($deleteme) {
	&DeleteArticle;
	exit 0;
}

else { 				#article not found.  Print useful message#

	print "Content-type: text/html\n\n";
	print "<HTML><HEAD><TITLE>Oops!</TITLE>\n";
	print "<meta HTTP-EQUIV=\"Refresh\" Content=\"1; URL=$RELCGI/htmls.pl/$cat/read\"";
	print "\n</HEAD>\n<BODY bgcolor=\"#000000\" text=\"#FFFFFF\">\n"; 
	print "<center><br><BR><BR>\n<h2>Can't find article";
	print " number ", $NUMBER, ". Sorry.\n";
	print "<br><br>\n<a href=\"$RELCGI/htmls.pl/$cat/read\">OK</a>\n";
	print "</BODY></HTML>";
	exit 0; 
}
#-------------

sub DeleteArticle {

	open (DB, $ABSOLUTE_DB_PATH) || PrintError("Couldn't open $ABSOLUTE_DB_PATH.");
	@posts = <DB>;			#read all posts into an array
	close(DB);

	#remove deleted article from array of posts
	#and rewrite to db

	@splitten=split(/\//, $deleteme);
	$filename=$splitten[@splitten-1];

	$i=0;
	until ($deleted || !$posts[$i]) {
		if ($posts[$i] eq $filename . "\n") {
			splice(@posts, $i, 1);	
			$deleted=1;
		}
		$i++;	
	}

	unless ($deleted) {
		 PrintError("ERROR: Post $filename not found in ",
				$DBPATH, "postfiles.<p>");
	}

	open(DBOUT, ">" . $ABSOLUTE_DB_PATH) ||
		 PrintError("Couldn't open $ABSOLUTE_DB_PATH for writing after modification.");
	print DBOUT @posts;
	close(DBOUT);
	
	#now unlink the article itself

	unlink ($deleteme) ||
		PrintError("Could not unlink $dbpath/posts/$deleteme<p>");

	print "Content-type: text/html\n\n";
	print "<HTML><HEAD><TITLE>Article Deleted</TITLE>\n";
	print "<meta HTTP-EQUIV=\"Refresh\" Content=\"1; URL=$RELCGI/htmls.pl/$cat/read\"";
	print "\n</HEAD>\n<BODY bgcolor=\"#000000\" text=\"#FFFFFF\">\n"; 
	print "<center><br><BR><BR>\n<h2>Article";
	print " number ", $NUMBER, " deleted.\n";
	print "<br><br>\n<a href=\"$RELCGI/htmls.pl/$cat/read\">OK</a>\n";
	print "</BODY></HTML>";
	exit 0; 
}
#end sub DeleteArticle

#------------------

sub ConfirmDeletion {

	print "Content-type: text/html\n\n";
	print "<HTML><HEAD><TITLE>Confirm Article Delete</TITLE>\n";
	print "\n</HEAD>\n<BODY bgcolor=\"#000000\" text=\"#FFFFFF\" "; 
	print " link=\"#FFFFFF\" vlink=\"#FFFFFF\">\n"; 
	print "<center><br><BR><BR>\n<h1>You are about to delete article";
	print " number ", $NUMBER, ".</h1>\n";
	print "<h2>Is this really what you want to do?</h2>\n";
	print "<form action=\"$RELCGI/delete.pl/$cat/\" method=\"post\">\n"; 
	print "<input type=\"hidden\" name=\"post\" value=\"$NUMBER\">\n";
	print "<input type=\"hidden\" name=\"confirmed\" value=\"1\">\n";
	print "<a href=\"$RELCGI/htmls.pl/$cat/bbmain/\">| NOPE! |</a><p>\n";
	print "<input type=\"submit\" value=\"YES!\"></form>\n";
	print "</BODY></HTML>";
	exit 0; 
}
# end sub ConfirmDeletion
